Installer - Bug #27847

foreman-proxy-certs-generate uses a value for --foreman-proxy-cname to add a DNS record even if it
is invalid
Description

foreman-proxy-certs-generate uses the value for --foreman-proxy-cname to add a DNS record in the SAN field regardless of that
setting making sense or not. E.g. DNS:[] and DNS: <= empty string.

This is what foreman-proxy-certs-generate is generating for gpid-router-server.crt: (used by capsules' qdrouterd on port 5647 to listen
to clients' goferds)

X509v3 Subject Alternative Name:
DNS:mycapsule.example.com, DNS: []

The DNS:[] comes from the default value for --foreman-proxy-cname:
[root@sat65a ~]# foreman-proxy-certs-generate --help

(...snip...)

= Module foreman_proxy_certs:

--certs-tar Path to tar file with certs to generate (current: UNDEF)
--foreman-proxy-cname additional names of the foreman proxy (current: ["[]']) <========= here
--foreman-proxy-fqdn FQDN of the foreman proxy (current: "sat65a.usersys.redhat.com")

Turns out, if you use “--foreman-proxy-cname
DNS: <====second DNS entry empty.

with “foreman-proxy-certs-generate’ it will still generate certs with DNS:<fqdn>,

The problem is that puppet-strings parses the default as the string "[]" rather than an empty array [].

Associated revisions

Revision 3beda1df - 09/16/2019 03:28 PM - Ewoud Kohl van Wijngaarden

Fixes #27847 - Refactor foreman_proxy_content class

e Move $parent_fqdn to Advanced Parameters since users generally don't
touch this

¢ Implement stricter data types

e Use modern facts

¢ Work around a kafo_parsers/puppet-strings limitation by using
class inheritance

Revision 425987e2 - 09/23/2019 04:02 PM - Ewoud Kohl van Wijngaarden
Refs #27847 - Set parameter mapping

In puppet-certs master the default values are loaded via params.pp to
workaround kafo limitations. This configures kafo to actually find it.
Otherwise it can't load the defaults and the values are nil.

Revision 265404ac - 09/23/2019 06:32 PM - Ewoud Kohl van Wijngaarden
Refs #27847 - Load CNAME default from params
3beda1df35481210b581f9beeb63d1dcafd2acal intended to load the variable

from params and even added it to params.pp, but missed using that
variable.

Revision f913ba18 - 09/24/2019 12:58 PM - Ewoud Kohl van Wijngaarden
Refs #27847 - Use legacy facts

In foreman-installer we test the command inside bundler. There is only a
facter 2 gem which doesn't have the modern facts. That means
S$facts['networking'] is undef and breaks, even though this won't be a
problem in production. In many places we still use legacy facts so this
reverts back to legacy facts.

History

#1 - 09/12/2019 05:04 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/puppet-certs/pull/256 added

#2 - 09/16/2019 03:28 PM - The Foreman Bot
- Fixed in Releases 1.24.0 added

#3 - 09/16/2019 04:01 PM - Ewoud Kohl van Wijngaarden
- Status changed from Ready For Testing to Closed

Applied in changeset puppet-certs|3bedaidf35481210b581f9beeb63d1dcafd2aca0.

#4 - 09/17/2019 03:59 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman-packaging/pull/4115 added

#5 - 09/17/2019 04:05 PM - Ewoud Kohl van Wijngaarden
- Pull request deleted (https://github.com/theforeman/foreman-packaging/pull/4115)

#6 - 09/17/2019 04:05 PM - Ewoud Kohl van Wijngaarden

- Category set to Foreman modules

- Assignee changed from Eric Helms to Ewoud Kohl van Wijngaarden
- Target version set to 1.24.0

- Triaged changed from No to Yes

#7 - 09/23/2019 04:06 PM - The Foreman Bot
- Pull request https://github.com/theforeman/puppet-certs/pull/259 added

#8 - 09/23/2019 04:07 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman-installer/pull/397 added

#9 - 09/24/2019 12:43 PM - The Foreman Bot
- Pull request https://github.com/theforeman/puppet-certs/pull/260 added
